package ims.hotcoref.io;

import ims.hotcoref.data.CoNLL12Sentence;
import ims.hotcoref.data.Document;
import ims.hotcoref.data.ISentence;
import ims.hotcoref.data.SemEval10Sentence;
import ims.hotcoref.data.DIRNDLAnaphSentence;


import java.io.File;
import java.util.List;
import java.util.regex.Pattern;

public class ColumnReader<T extends ISentence> extends AbstractReader {

	public static final Pattern WS=Pattern.compile("\\s+");
	public final Class<T> sentenceClass;
	
	public ColumnReader(File input, String enc, boolean gzipped,Class<T> sentenceClass) {
		super(input, enc, gzipped);
		this.sentenceClass=sentenceClass;
	}

	@Override
	ISentence createSentence(List<String> lines, int senIndex,Document d) {
		if(sentenceClass==CoNLL12Sentence.class){
			return CoNLL12Sentence.makeSentence(lines, senIndex, d);
		} else if(sentenceClass==SemEval10Sentence.class){
			return SemEval10Sentence.fromLines(lines, senIndex, d);
		}
			else if(sentenceClass==DIRNDLAnaphSentence.class){
				return DIRNDLAnaphSentence.makeSentence(lines, senIndex, d);
		}
		return null;
	}
	
}
