package ims.hotcoref.io;

import ims.hotcoref.Options;
import ims.hotcoref.data.ISentence;

import java.io.File;
import java.io.IOException;

public class ReaderWriterFactory {

	public static DocumentReader getInputReader(Options options) throws IOException{
		return getColumnReader(options.in,options.inputFormat.clazz);
	}

	public static DocumentWriter getOutputWriter(Options options) throws IOException {
		return getColumnWriter(options.out);
	}

	public static <T extends ISentence> ColumnReader<T> getColumnReader(File input,Class<T> sentenceClass) throws IOException {
		return new ColumnReader<T>(input, "UTF-8", false, sentenceClass);
	}
	
	public static DocumentWriter getColumnWriter(File output) throws IOException{
		return new ColumnWriter(output);
	}
	
	public static HTMLWriter getHTMLWriter(File output) throws IOException{
		return new HTMLWriter(output);
	}

	public static DocumentReader getReader(CorefFormat inputFormat, File in, boolean inGz, String inputEnc) throws IOException {
		return getColumnReader(in,inputFormat.clazz);
	}
	
}
