package ims.hotcoref.markables;

import ims.hotcoref.data.DepTree;
import ims.hotcoref.data.ISentence;
import ims.hotcoref.data.Span;

import java.util.Set;

public class SubTreeExtractor extends AbstractMarkableExtractor{
	private static final long serialVersionUID = 1L;
	
	public final String tag;
	
	public SubTreeExtractor(String tag){
		this.tag=tag;
	}

	@Override
	public void extractMarkables(ISentence s, Set<Span> sink,String docName) {
		DepTree dt=s.getDepTree();
		for(int i=1;i<s.getLength();++i){
			if(take(s.getTag(i))){
				Span sp=dt.getSubTreeSpan(i,s);
				sink.add(sp);
			}
		}
	}

	boolean take(String tag){
		return tag.startsWith(this.tag);
	}

	public String toString() {
		return "ST-"+tag;
	}
}
