//requires a tab-separated list of word <tab> word2 <tab> similarity
package ims.hotcoref.util;

import ims.hotcoref.Options;
import ims.hotcoref.data.Span;
import ims.hotcoref.features.enums.Gender;
import ims.hotcoref.features.enums.Num;
import ims.util.Util;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.regex.Pattern;
import java.util.zip.ZipEntry;
import java.util.zip.ZipFile;
import java.util.zip.ZipOutputStream;

public class DistributionalSimilarityLookup implements Serializable{
	private static final long serialVersionUID = 1L;
	

	public static ArrayList<String> similarities=new ArrayList<String>();
	
	
	public static void main(String[] args) throws IOException, ClassNotFoundException{
	
		DistributionalSimilarityLookup.lookupSimilarities();
	
	}

public static void lookupSimilarities () throws IOException, ClassNotFoundException {
		
	
			if(Options.similarityList==null){
				System.out.println("didnt initialize similarity list -- no path given");
			}
		
			else {
		
			System.out.println("Using similarity information");
			File f=Options.similarityList;//"//fs/tmp-local/users/roesigia/similarities_cosim.txt
			//File f=new File("/fs/tmp-local/users/roesigia/similarities_cosim.txt");

			if (f.exists()){

				BufferedReader reader=Util.getReader(f);
				String line;
				System.out.println("starting to save similarity values");

				while((line=reader.readLine())!=null){		
					
					if (line.split("\t").length>1){
						String[] splits=line.split("\t");
						String word1=splits[0];
						String word2=splits[1];
						float similarity=Float.parseFloat(splits[2]);
				
						//define similarity threshold here 
						if (similarity>0.8&&similarity!=1.0){
							similarities.add(word1.toLowerCase()+","+word2.toLowerCase());
						}					
					}
				}
				System.out.println("finished saving similarity values");
				System.out.println("Size of similarity list: "+similarities.size());
			}
			}
}
		
		
	
}