package ims.hotcoref.util;

import ims.hotcoref.Options;
import ims.hotcoref.features.enums.SemanticClass;
import germanet.*;

import java.io.*;
import java.util.*;

import javax.xml.stream.XMLStreamException;

public class GermaNetInterface {
	
	public static GermaNet initialise() throws FileNotFoundException, XMLStreamException{
		
		if(Options.germaNetDictDir==null){
			System.out.println("didnt initialize germanet -- no path given");
			return null;
			
		} else {
			GermaNet gnet=GermaNetInterface.theInstance(Options.germaNetDictDir);
		return gnet;
		}
		
	}
	
	
	public static void main(String[] args) throws XMLStreamException, ClassNotFoundException, IOException{
		
		File gnetDir;
		gnetDir = new File("/resources/data/GermaNet/GN_V60");
		if (gnetDir.exists()){
			GermaNet gnet = new GermaNet(gnetDir);
			System.out.println("loaded GermaNet");	
		
			//pair test synonyms
			Boolean pair=GermaNetInterface.synonymLookup("Sitzbank","Bank",gnet); //first word must be capitalised!
			System.out.println(pair);
		
			//pair test hyponyms
			Boolean pair2=GermaNetInterface.hyponymLookup("Decke","Bettdecke",gnet); 
			System.out.println(pair2);
		
			//pair test hyperonyms
			Boolean pair3=GermaNetInterface.hypernymLookup("Bettdecke","Decke",gnet); 
			System.out.println(pair3);

		//general GermaNet test
	/*	String word = "Bohrer";
		List<Synset> synsets;
		synsets = gnet.getSynsets(word);
		System.out.println("synsets loaded for "+word);

		if (synsets.size() == 0){
		System.out.println(word + " not found in GermaNet");
		System.exit(0);
		}

		List<LexUnit> lexUnits;
		List<Synset> hypernyms = new ArrayList<Synset>();
		List<Synset> hyponyms = new ArrayList<Synset>();
		
		//for every synset that word x belongs to do
		for (Synset syn : synsets) {
			WordCategory wc = syn.getWordCategory();
			
			if (wc == WordCategory.nomen) {
				System.out.println("noun synset found\n searching for synonyms");	
				
				lexUnits = syn.getLexUnits();
				
				//find synonyms
				for (int i=0;i<lexUnits.size();i++){
					String orthForm = lexUnits.get(i).getOrthForm();
					System.out.println(orthForm);
				}
				
				//find hypernyms
				System.out.println("found hypernyms: ");
				hypernyms=syn.getRelatedSynsets(ConRel.has_hypernym);
				
				for (Synset hyperos : hypernyms) {
					lexUnits = hyperos.getLexUnits();
					for (int i=0;i<lexUnits.size();i++){
						String orthForm = lexUnits.get(i).getOrthForm();
						System.out.println(orthForm);
					}	
				}
				
				//find hyponyms
				System.out.println("found hyponyms: ");

				hyponyms =syn.getRelatedSynsets(ConRel.has_hyponym);
				for (Synset hypos : hyponyms) {
					lexUnits = hypos.getLexUnits();
					for (int i=0;i<lexUnits.size();i++){
						String orthForm = lexUnits.get(i).getOrthForm();
						System.out.println(orthForm);
					}	
				}
				
				
				//	meronyms not directly relevant for coreference, more for bridging !
				  System.out.println("searching for meronyms");
					//find meronyms
					List<Synset> meronyms =
							syn.getRelatedSynsets(ConRel.has_member_meronym);
					for (Synset meros : meronyms) {
						
						lexUnits = meros.getLexUnits();
						
						for (int i=0;i<lexUnits.size();i++){
							String orthForm2 = lexUnits.get(i).getOrthForm();
							System.out.println(orthForm2);
						}
						
					}*/
					
				
				
				//possible relations
				
				/*aSynset.getRelatedSynsets(ConRel.has_hypernym);
				aSynset.getRelatedSynsets(ConRel.has_hyponym);
				aSynset.getRelatedSynsets(ConRel.has_component_meronymy);
				aSynset.getRelatedSynsets(ConRel.has_component_holonymy);
				aSynset.getRelatedSynsets(ConRel.has_member_meronymy);
				aSynset.getRelatedSynsets(ConRel.has_member_holonymy);
				aSynset.getRelatedSynsets(ConRel.has_substance_meronymy);
				aSynset.getRelatedSynsets(ConRel.has_substance_holonymy);
				aSynset.getRelatedSynsets(ConRel.has_portion_meronymy);
				aSynset.getRelatedSynsets(ConRel.has_portion_holonymy);
				aSynset.getRelatedSynsets(ConRel.is_related_to);
				aSynset.getRelatedSynsets(ConRel.causes);
				aSynset.getRelatedSynsets(ConRel.entails);
				aSynset.getRelatedSynsets(ConRel.is_entailed_by);	
				}
		}*/
		
	/*	//transitive hyponyms
		List<List<Synset>> transHyponyms;
		List<Synset>synList = gnet.getSynsets("Decke");
		String spaces;
		for (Synset s : synList) {
			spaces = "";
			transHyponyms = s.getTransRelations(ConRel.has_hyponym);
			for (List<Synset> listAtDepth : transHyponyms) {
				for (Synset synAtDepth : listAtDepth) {
					System.out.println(spaces + synAtDepth.getAllOrthForms());
				}
				spaces += "";
			}
		}*/
			
		}}
	
	
	public static GermaNet theInstance (File gnetDir) throws FileNotFoundException, XMLStreamException {
	//	File gnetDir;
	//	gnetDir = new File("/resources/data/GermaNet/GN_V60");
		if (gnetDir.exists()){
			GermaNet gnet = new GermaNet(gnetDir);
			System.out.println("loaded GermaNet");		
			return gnet;
			
		}
		return null;
	}
	
	//are words synonyms?
	public static Boolean synonymLookup (String a, String b, GermaNet gnet) throws IOException, ClassNotFoundException {
		
		List<Synset> synsets;
		synsets = gnet.getSynsets(a);

		if (synsets.size() == 0)
			return false;
		else {
		List<LexUnit> lexUnits;
		
		//for every synset that word x belongs to do
		for (Synset syn : synsets) {
			WordCategory wc = syn.getWordCategory();
			
			if (wc == WordCategory.nomen) {
				lexUnits = syn.getLexUnits();
	
				//find synonyms
				for (int i=0;i<lexUnits.size();i++){
					String orthForm = lexUnits.get(i).getOrthForm();
					
					if (b.equalsIgnoreCase(orthForm)){
						return true;
					}
				}}}	
		}	
		return false;
	}
	

	//word b hyponym of a?
	public static Boolean hyponymLookup (String a, String b,GermaNet gnet) throws IOException, ClassNotFoundException {
		
		List<Synset> synsets;
		synsets = gnet.getSynsets(a);

		if (synsets.size() == 0)
			return false;
		else {
			
		//transitive hyponyms
				List<List<Synset>> transHyponyms;
				for (Synset s : synsets) {
					transHyponyms = s.getTransRelations(ConRel.has_hyponym);
					for (List<Synset> listAtDepth : transHyponyms) {
						for (Synset synAtDepth : listAtDepth) {
							if (synAtDepth.getAllOrthForms().contains(b)){
								return true;
						}}
					}
				}
		}
		return false;
	}
	
		
	//word b hypernym of a?
	public static Boolean hypernymLookup (String a, String b,GermaNet gnet) throws IOException, ClassNotFoundException {
		
		List<Synset> synsets;
		synsets = gnet.getSynsets(a);

		if (synsets.size() == 0)
			return false;
		else {
			
		//transitive hyponyms
				List<List<Synset>> transHyponyms;
				for (Synset s : synsets) {
					transHyponyms = s.getTransRelations(ConRel.has_hypernym);
					for (List<Synset> listAtDepth : transHyponyms) {
						for (Synset synAtDepth : listAtDepth) {
							if (synAtDepth.getAllOrthForms().contains(b)){
								return true;
						}}
					}
				}
		}
		return false;
	}
			

}
